local AddonName, VoiceCoolDown = ...
local oVoiceCoolDown = LibStub("AceAddon-3.0"):NewAddon(VoiceCoolDown, AddonName, "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("VoiceCoolDown") --Objeto para la gestión de la localización
local ACD = LibStub("AceConfigDialog-3.0")


local CLASES_ENUM = {
	[1]		= "ANY",
	[2]		= "DEATHKNIGHT",
	[3]		= "DRUID",
	[4]		= "HUNTER",
	[5]		= "MAGE",
	[6]		= "MONK",
	[7]		= "PALADIN",
	[8]		= "PRIEST",
	[9]		= "ROGUE",
	[10]	= "SHAMAN",
	[11]	= "WARLOCK",
	[12]	= "WARRIOR",
}

local HECHIZOS_PORDEFECTO = {
	{"ANY",			59752,	nil},					-- Every Man for Himself
	{"ANY",			20594,	nil},					-- Stoneform: this is the spell in the spellbook
	--{"ANY",			65116,	nil},				-- Stoneform: this is the buff spell effect
	
	{"DRUID",		22812,	nil},					-- Barkskin
	{"DRUID",		22842,	nil},					-- Frenzied Regeneration
	{"DRUID",		29166,	nil},					-- Innervate
	{"DRUID",		20484,	nil},					-- Rebirth
	{"DRUID",		61336,	nil},					-- Survival Instincts
	{"DRUID",		740,	nil},					-- Tranquility
	{"DRUID",		33891,	nil},					-- Tree of Life
	{"DRUID",		5211,	nil},					-- Mighty Bash
	{"DRUID",		102351,	nil},					-- Cenarion Ward (Talent - 5.0)
	{"DRUID",		102342,	nil},					-- Ironbark (5.0)
	{"DRUID",		124974,	nil},					-- Nature's Vigil
  {"DRUID",		102280,	nil},					-- Bestia Tremula
  {"DRUID",		5215,	nil},					  -- Acechar
	
	{"HUNTER",		34477,	nil},					--Misdirection
  {"HUNTER",		19263,	nil},					--Disuasion
	
	{"MAGE",		45438,	nil},					-- Ice Block
	{"MAGE",		31687,	nil},					-- Summon Water Elemental
	{"MAGE",		80353,	nil},					-- Time Warp
	{"MAGE",		2139,	nil},					-- Counterspell
	
	{"MONK",		115176,	nil},					-- Zen Meditation
	{"MONK",		116849,	nil},					-- Life Cocoon
	{"MONK",		115310,	nil},					-- Revival
	                                                   
	{"PALADIN",		31850,	nil},					-- Ardent Defender
	{"PALADIN",		31821,	nil},					-- Devotion Aura
	{"PALADIN",		498,	nil},					-- Divine Protection
	{"PALADIN",		642,	nil},					-- Divine Shield
	{"PALADIN",		1044,	nil},					-- Hand of Freedom
	{"PALADIN",		1022,	nil},					-- Hand of Protection
	{"PALADIN",		6940,	nil},					-- Hand of Sacrifice
	{"PALADIN",		1038,	nil},					-- Hand of Salvation
	{"PALADIN",		114039,	nil},					-- Hand of Purity
	{"PALADIN",		633,	nil},					-- Lay on Hands
	{"PALADIN",		20066,	nil},					-- Repentance
	{"PALADIN",		86659,	nil},					-- Guardian of Ancient Kings
	{"PALADIN",		96231,	nil},					-- Rebuke
	{"PALADIN",		853,	nil},					-- Hammer of Justice
	{"PALADIN",		105593,	nil},					-- Fist of Justice (5.0.4)
	                                                   
	{"PRIEST",		64843,	nil},					-- Divine Hymn
	{"PRIEST",		47788,	nil},					-- Guardian Spirit
	{"PRIEST",		64901,	nil},					-- Hymn of Hope
	{"PRIEST",		33206,	nil},					-- Pain Suppression
	{"PRIEST",		109964,	nil},					-- Spirit Shell (added in 5.0.4)
	{"PRIEST",		73325,	nil},					-- Leap of Faith
	{"PRIEST",		62618,	nil},					-- Power Word:Barrier
	{"PRIEST",		15286,	nil},					-- Vampiric Embrace
	{"PRIEST",		108968,	nil},					-- Void Shift
	{"PRIEST",		108920,	nil},					-- Void Tendrils (5.0.4)
	{"PRIEST",		113277,	nil},					-- Tranquility: Symbiosis (5.0.4)
	                                                   
	{"ROGUE",		2094,	nil},					-- Blind
	{"ROGUE",		31224,	nil},					-- Cloak of Shadows
	{"ROGUE",		57934,	nil},					-- Tricks of the Trade
	{"ROGUE",		1766,	nil},					-- Kick
	{"ROGUE",		114018,	nil},					-- Shroud of Concealment
	{"ROGUE",		76577,	nil},					-- Smoke Bomb
	                                                   
	{"SHAMAN",		2825,	"Horde"},				-- Bloodlust
	{"SHAMAN",		32182,	"Alliance"},			-- Heroism
	{"SHAMAN",		20608,	nil},					-- Reincarnation
	{"SHAMAN",		16190,	nil},					-- Mana Tide Totem
	{"SHAMAN",		98008,	nil},					-- Spirit Link Totem
	{"SHAMAN",		57994,	nil},					-- Wind Shear
	{"SHAMAN",		108280,	nil},					-- Healing Tide Totem
	{"SHAMAN",		5394,	nil},					-- Healing Stream Totem
	{"SHAMAN",		108281,	nil},					-- Ancestral Guidance
	{"SHAMAN",		2484,	nil},					-- totem nexo  
	                                                   
	{"WARLOCK",		698,	nil},					-- Ritual of Summoning
	{"WARLOCK",		29893,	nil},					-- Ritual of Souls
	{"WARLOCK",		20707,	nil},					-- Soulstone Resurrection
	                                                   
	{"WARRIOR",		871,	nil},					-- Shield Wall
	{"WARRIOR",		64382,	nil},					-- Shattering Throw
	{"WARRIOR",		12975,	nil},					-- Last Stand
	{"WARRIOR",		97462,	nil},					-- Rallying Cry
	{"WARRIOR",		6552,	nil},					-- Pummel
	{"WARRIOR",		102060,	nil},					-- Disrupting Shout
	{"WARRIOR",		114028,	nil},					-- Mass Spell Reflection
	{"WARRIOR",		114207, nil},					-- Skull Banner
	{"WARRIOR",		114203, nil},					-- Demoralizing Banner
	                                                   
	{"DEATHKNIGHT",	49576,	nil},					-- Death Grip
	{"DEATHKNIGHT",	48792,	nil},					-- Icebound Fortitude
	{"DEATHKNIGHT",	48707,	nil},					-- Anti-Magic Shell
	{"DEATHKNIGHT",	61999,	nil},					-- Raise Ally
	{"DEATHKNIGHT",	42650,	nil},					-- Army of the Dead
	{"DEATHKNIGHT",	49222,	nil},					-- Bone Shield
	{"DEATHKNIGHT",	55233,	nil},					-- Vampiric Blood
	{"DEATHKNIGHT",	46584,	nil},					-- Raise Dead
	{"DEATHKNIGHT",	51052,	nil},					-- Anti-Magic Zone
	{"DEATHKNIGHT",	47528,	nil},					-- Mind Freeze			--new
	{"DEATHKNIGHT",	47476,	nil},					-- Strangulate			--new
	{"DEATHKNIGHT",	49028,	nil},					-- Dancing Rune Weapon
	{"DEATHKNIGHT",	49039,	nil},					-- Lichborne
	{"DEATHKNIGHT",	48743,	nil},					-- Death Pact
}

--formulario del addon, donde se almacenan los datos que introduce el usuario en la ventana de configuración
--que no se guaradan en una savedvariables.
local formulario = {
  nombrenuevousuario = "", --Cada nuevo usuario se guarda aqui 
}
-- Estrutura de datos para AceDB, esta es la estrutura de datos que usa AceDB para guardar las savedvariables
local defaults = {
  global = { 
    --Indica si el addon esta activo o no, activando o no la recepción del evento COMBAT_LOG_EVENT_UNFILTERED 
    Activo = true,
    Maestro = true, -- Usar canal Maestro o no?
    RutaVoces = "Interface\\AddOns\\VoiceCoolDown\\Voces\\"
  },
  profile = {
		minimap = {
			hide = false,
		},
    hechizosEnCD = {}, --Esta Variable almacena como indice el identificador del timer y el spellid que monitoriza
    hechizosMonitorizados = {} -- Variable que contiene los idspell a monitorizar
	},
}

--Estructura del frame de configuracion, lo usa Ace3-Config y Ace3-ConfigDialog
local options = {
  type = "group",
  childGroups = "tab",
  args = {
    generales={
      name = L["C_N_GENERAL"],
      desc = L["C_D_GENERAL"],
      type = "group",
      order = 0,
      args={
        activo = {
          name = L["C_N_ACTIVO"],
          desc = L["C_D_ACTIVO"],
          type = "toggle",
          order = 2,
          --width = "half",
          disabled = function()
            --Si estamos en situación de proceso de datos no debo
            --poder activar ni desactivar el addon para evitar
            --que se quede en situaciones no contempladas
            return (oVoiceCoolDown.EnCombate or oVoiceCoolDown.EnModoPrueba) 
          end,
          set = function(info, value) 
            -- Registramos o Desregistramos los eventos para activar o desactivar el addon.
            -- Cuando estemos en combate o en modo prueba esta opcion no se puede modificar
            oVoiceCoolDown.db.global.Activo = value
            if oVoiceCoolDown.db.global.Activo then 
              self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            else
              self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:UnregisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:UnregisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:UnregisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            end
          end,
          get = function()
            return oVoiceCoolDown.db.global.Activo
          end
        },
        maestro = {
          name = L["C_N_MAESTRO"],
          desc = L["C_D_MAESTRO"],
          type = "toggle",
          order = 3,
          --width = "half",
          set = function(info, value) 
            -- Utiliza el canal maestro o no para las voces
            oVoiceCoolDown.db.global.Maestro = value  
          end,
          get = function()
            return oVoiceCoolDown.db.global.Maestro
          end
        },
        modoprueba = {
          name = L["C_N_MODO_PRUEBA"],
          desc = L["C_D_MODO_PRUEBA"],
          type = "toggle",
          order = 4,
          --width = "half",
          set = function(info, value) 
            oVoiceCoolDown.EnModoPrueba = value
            if oVoiceCoolDown.EnModoPrueba then 
              oVoiceCoolDown:Print(L["MODO_PRUEBA_ACTIVO"])
            else
              oVoiceCoolDown:Print(L["MODO_PRUEBA_DESACTIVADO"])
            end
          end,
          get = function()
            return oVoiceCoolDown.EnModoPrueba
          end
        },
        ejemplo = {
          type = "execute",
          name = L["C_N_EJEMPLO"],
          desc = L["C_D_EJEMPLO"],
          width = "full",
          order = 1,
          func = function()
            if VoiceCoolDown.db.global.Maestro then
              PlaySoundFile(VoiceCoolDown.db.global.RutaVoces.."1068068"..".mp3","Master")
            else
              PlaySoundFile(VoiceCoolDown.db.global.RutaVoces.."1068068"..".mp3")
            end  
          end,
        },
      }
    },
    hechizos={
      name = L["C_N_HECHIZOS"],
      desc = L["C_D_HECHIZOS"],
      type = "group",
      order = 1,
      args={} -- Se añaden las opciones dinamicamente en la funcion ConfigMonitorizedSpells)
    },
    roster={
      name = L["C_N_ROSTER"],
      desc = L["C_D_ROSTER"],
      type = "group",
      order = 2,
      args={
        botonesroster={
          name = "Añadir jugador",
          --desc = L["C_D_ROSTER"],
          type = "group",
          inline = true,
          args={
            NombreNuevoMiembro = {
              type = "input",
              name = L["C_N_ENTRADAJUGADOR"],
              desc = L["C_N_ENTRADAJUGADOR"],
              order = 1,
              width = "normal",
              get = function(info)
                if(formulario.nombrenuevousuario ~= nil) then return formulario.nombrenuevousuario
                else return "" end
              end,
              set = function(info, value)
					     formulario.nombrenuevousuario = strtrim(value)					
              end,
            },
            AnadirMiembroBoton = {
              type = "execute",
              name = L["C_N_ANADIRJUGADOR"],
              desc = L["C_D_ANADIRJUGADOR"],
              width = "normal",
              order = 2,
              func = function()
                --if core:AddSpell(tonumber(newSpellTemplate.id), newSpellTemplate.name, newSpellTemplate.class) then
                  --reset the entered data
                  --newSpellTemplate.id = nil
                  --newSpellTemplate.name = nil
						
                  --force the config window to update with latest spell info
                  --LIB_AceConfigRegistry:NotifyChange(HERMES_VERSION_STRING)
                  --core:BlizOptionsTable_Spells()
                  --core:BlizOptionsTable_Maintenance()
                --end
              end,
              disabled = function()
                --ensure that a class is selected and that spell evaluates to a spell id or name
                --return newSpellTemplate.class == L["-- Select --"] or (not newSpellTemplate.name and not newSpellTemplate.id)
              end,
            },
            AnadirBandaBoton = {
              type = "execute",
              name = L["C_N_ANADIRJUGADORESGRUPO"],
              desc = L["C_D_ANADIRJUGADORESGRUPO"],
              width = "normal",
              order = 3,
              func = function()
                --if core:AddSpell(tonumber(newSpellTemplate.id), newSpellTemplate.name, newSpellTemplate.class) then
                  --reset the entered data
                  --newSpellTemplate.id = nil
                  --newSpellTemplate.name = nil
						
                  --force the config window to update with latest spell info
                  --LIB_AceConfigRegistry:NotifyChange(HERMES_VERSION_STRING)
                  --core:BlizOptionsTable_Spells()
                  --core:BlizOptionsTable_Maintenance()
                --end
              end,
              disabled = function()
                --ensure that a class is selected and that spell evaluates to a spell id or name
                --return newSpellTemplate.class == L["-- Select --"] or (not newSpellTemplate.name and not newSpellTemplate.id)
              end,
            },
          } 
        },
        cuerporoster={
          name = "Lista roster",
          --desc = L["C_D_ROSTER"],
          type = "group",
          inline = true,
          width = "full",
          args={} -- Se añaden las opciones dinamicamente en la funcion ConfigMonitorizedSpells)
        }
      } 
    }
  }
}


--Variables que no es necesario guardar cada vez que conectas/desconectas SAVEDVARIABLES
VoiceCoolDown.Hablando = {} -- Para evitar reproducir dos cooldown simultaneos y que se superpongan, esta variable lo controla
VoiceCoolDown.HoraComienzoCombateActual = time() --Contiene la hora a la que comienza el combate actual
VoiceCoolDown.HoraFinCombateActual = time() --Contiene la hora a la que termina el combate actual
VoiceCoolDown.TiempoTotalCombateActual = time() -- Duración del combate actual
VoiceCoolDown.RLOrdenaWipe = 0 --Esta variable determina si el RL ha indicado Wipe, Cada vez que comienze un combate se establece a 0
VoiceCoolDown.EnCombate = false --Esta variable determina si estamos en combate o no
VoiceCoolDown.EnModoPrueba = false --Esta claro no? sino lo ves dedicate a otra cosa.... 
VoiceCoolDown.MinimapButton = nil --Contendra un objeto LDB que definira los parametro del boton del minimapa
VoiceCoolDown.MinimapButtonIcon = nil --Contendra el objeto que crea un boton del minimapa a partir del objeto LDB anterior
VoiceCoolDown.db = nil --Contiene el objeto que almacena los datos de configuración para savedvariables.


function VoiceCoolDown:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("VoiceCoolDownDB", defaults) --Recupera datos guardados de la anterior sesión
  
  self:ConfigMonitorizedSpells() --Esta linea debe de ir antes que la siguiente ya que carga adecuadamente el parametro "options"
  LibStub("AceConfig-3.0"):RegisterOptionsTable("VoiceCoolDown", options, "cvdconfig")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VoiceCoolDown")
  LibStub("AceConfigDialog-3.0"):SetDefaultSize("VoiceCoolDown",700,400)
  self:RegisterChatCommand("TBRWipe","RLWipe") --El RL mediante este comando indica que ha decidido wipe para el encuentro y se deja de tomar datos
  self:RegisterChatCommand("TBRShowIcon","ShowIcon") --Muestra u oculta el icono del minimapa.
  self:RegisterChatCommand("TBR",function() self:Print( L["ADDON_DESC"])  end)
  self:CreateMinimapButton()
end

function VoiceCoolDown:OnEnable()
--Este evento se produce cuando el addon ya esta cargado
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
  --self:RegisterEvent("ZONE_CHANGED_NEW_AREA","DetectInstanceChange") --Si cambia de instancia -> reset de la tabla almacenada?
  self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged") --Si hay modificaciones en el grupo tengo que recalcular la estructura del grupo
  self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat") --Este evento se produce cuando el jugador entra en combate
  self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") --Este evento se produce cuando el jugador entra en combate
end

function VoiceCoolDown:EventEndTimer(HechizoID)
  
  local nombreHechizo = GetSpellInfo(HechizoID)
  
  self:Print("|cffffff00-------------------")
  self:Print("Disponible de nuevo")
  self:Print(HechizoID.." "..nombreHechizo)
  self:PlaySoundFile(nil,"disponible",tostring(HechizoID))
end
function VoiceCoolDown:EventCombatLog(event, ...)
--Esta función se activa cuando se dispara un evento de COMBAT_LOG_EVENT_UNFILTERED

  local idTimer
  local timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, srcFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName = select(1, ...)
  local duration
  local postCD = false
  
  if not self:QProcessEventCombat() then return end
    
  if self:IsPlayerInGroup(sourceName) or --Si es alguien del grupo ó.....
     (self.EnModoPrueba and (sourceGUID == UnitGUID("player"))) then --ó Si soy yo y estoy modoprueba    
    if self:IsMonitorizedSpell(spellID) then --Si esta en la lista de hechizos a monitorizar
      duration = VoiceCoolDown.SPELL_MONITOR_SCHEMA.cooldowns[spellID]
      if duration < 0 then 
        duration = -1*duration
        postCD = true
      end
      self:Print("|cffffff00-------------------")
      self:Print(ChatFrame1,spellID.." "..spellName)
      self:Print(ChatFrame1,eventType)
      self:Print(ChatFrame1,duration)
      self:Print(ChatFrame1,"Hechizo incluido")
      if eventType == "SPELL_CAST_SUCCESS" then
        self:PlaySoundFile(sourceName,"lanzo",tostring(spellID))
        if not postCD then 
          idTimer = self:ScheduleTimer("EventEndTimer", duration, spellID)
        end
      elseif eventType == "SPELL_AURA_REMOVED" then
        if postCD then 
          idTimer = self:ScheduleTimer("EventEndTimer", duration, spellID)
        end
      end
    end
  end
end
function VoiceCoolDown:EventStartCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_ENABLED y se limita a llamar
--a la función StartCombat que es la que inicializa todo lo necesario cuando comienza
--un combate.

  self:StartCombat()
end
function VoiceCoolDown:EventFinishCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_DISABLED y se limita a llamar
--a la función FinishCombat que es la que calcula y procesa todo lo necesario cuando ha
--terminado un combate.

  self:FinishCombat()
end
function VoiceCoolDown:StartCombat()
--Esta función inicia las variables necesarias cuando comienza el combate, 
--es llamada en el programa cuando se detecta el inicio de un combate

  self.HoraComienzoCombateActual = time() --Establece la hora de comienzo del combate
  self.EnCombate = true --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  
end
function VoiceCoolDown:FinishCombat()
--Esta funcion determina establece las variables necesarias cuando termina un combate
--y realiza los calculos necesarios al finalizar un combate.

  self.EnCombate = false --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  self.HoraFinCombateActual = time() --Establece la hora de fin del combate
  self.TiempoTotalCombateActual = self.HoraFinCombateActual-self.HoraComienzoCombateActual
  self:Print(date("Tiempo total de combate is %M:%S",self.TiempoTotalCombateActual))
end
function VoiceCoolDown:RLWipe()
  self.RLOrdenaWipe = 1 --Esta variable cesa en la recolección de datos
  self:Print( L["WIPE"])
end
function VoiceCoolDown:ShowIcon()
  self:Print( self.db.profile.minimap.hide)
  self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	if self.db.profile.minimap.hide then
		self.MinimapButtonIcon:Hide("VoiceCoolDown!")
	else
    self.MinimapButtonIcon:Show("VoiceCoolDown!")
	end
  self:Print( self.db.profile.minimap.hide)
end

function VoiceCoolDown:CheckForWipe()
--Determina si ha habido wipe
	local wipe = true
	local num = GetNumGroupMembers()
	for i = 1, num do
		local name = GetRaidRosterInfo(i)
		if name then
			if UnitAffectingCombat(name) ~= nil then
				wipe = false
			end
		end
	end
	return wipe
end


function VoiceCoolDown:PartyMembersChanged()
--Esta función se ejecuta solo si se dispara el evento de GROUP_ROSTER_UPDATE
end
function VoiceCoolDown:GetGroupTypeAndCount()
--Determina el tipo de grupo: Party ó Raid y el número de miembros

	local type = "none"
	local count = GetNumGroupMembers()
	if IsInRaid() then
		type = "raid"
	elseif IsInGroup() then
		type = "party"
	end
  return type, count
end
function VoiceCoolDown:CreateMinimapButton()
--Utiliza para ello las librerias LDB y LDBI, crea un objeto
--LDB y lo registra como un icno del minimapa a través
--de un objeto LDBI
	local LDB = LibStub("LibDataBroker-1.1", true)
	if not LDB then return end
	self.MinimapButton = LDB:NewDataObject("VoiceCoolDown!", {
		type = "launcher",
		text = "VoiceCoolDown!",
		icon = "Interface\\AddOns\\VoiceCoolDown\\Images\\TBRMinimapButton",
		OnClick = function(_, button)
      --self:Print("|cffffff00----------------------------------")
      if button == "RightButton" then 
        if self:IsConfigWindowOpen() then return end
        self.EnModoPrueba = not self.EnModoPrueba
        if self.EnModoPrueba then 
          self:Print(L["MODO_PRUEBA_ACTIVO"])
          self:Print(VoiceCoolDown.SPELL_MONITOR_SCHEMA.schema)
        else
          self:Print(L["MODO_PRUEBA_DESACTIVADO"])
        end
      elseif button == "LeftButton" then 
        if self:IsConfigWindowOpen() then return end
        self:RLWipe()
      else
        if self:IsConfigWindowOpen() then 
          ACD:Close("VoiceCoolDown")
        else
          ACD:Open("VoiceCoolDown")
        end
      end
    end,
    OnTooltipShow = function(tt)
      tt:AddLine("VoiceCoolDown")
      tt:AddLine("|cffffff00" .. L["TOOLTIP_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP2_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP3_MINIMAP"])
    end,
	})
	self.MinimapButtonIcon = LibStub("LibDBIcon-1.0", true)
	if self.MinimapButtonIcon then self.MinimapButtonIcon:Register("VoiceCoolDown!", self.MinimapButton, self.db.profile.minimap) end
end
function VoiceCoolDown:QProcessEventCombat()
--Esta función determina si hay que guardar el evento de combate. Es llamada en EventCombatLog
--Si devuelve true -> Procesa el evento de combate en curso.

  return  (not(self.RLOrdenaWipe) or self.EnCombate or self.EnModoPrueba)
end
function VoiceCoolDown:IsMonitorizedSpell(HechizoID)
--Comprueba que el hechizo que se ha pasado por argumento este en la lista de hechizos a procesar en el combat log
--Esta funcion se llama desde la funcion que responde a los eventos de combat log

  if #self.db.profile.hechizosMonitorizados <= 0 then return false end
  for i, v in ipairs(self.db.profile.hechizosMonitorizados) do
    if v == HechizoID then return true end
  end
  return false
end
function VoiceCoolDown:DelMonitorizedSpell(HechizoID)
--Elimina el spell pasado por parametro de la lista de hechizos a monitorizar
  
  for i, v in ipairs(self.db.profile.hechizosMonitorizados) do
    if v == HechizoID then table.remove(self.db.profile.hechizosMonitorizados, i) end
  end
end
function VoiceCoolDown:AddMonitorizedSpell(HechizoID)
--Mete el spell pasado por parametro en la lista de hechizos a monitorizar

  if not self:IsMonitorizedSpell(HechizoID) then
    self.db.profile.hechizosMonitorizados[#self.db.profile.hechizosMonitorizados+1] = HechizoID
  end
end
function VoiceCoolDown:IsPlayerInGroup(jugador)
--Esta función determina si username esta en banda, si es así procesara los spell del combat log
  
  local tipo -- Tipo de grupo = "party" o "banda" 
  local numero -- Cantidad de miembros en el grupo

  if not self:QProcessEventCombat() then return nil end --Si no esta en modo procesamiento -> No hay que comprobar
  
  tipo, numero = self:GetGroupTypeAndCount()
  if numero > 0 then 
    for i = 1, numero do 
      if jugador == GetRaidRosterInfo(i) then return true end
    end
  end
  return  false
end

function VoiceCoolDown:IsConfigWindowOpen()
--Es una función que determina si la ventana de configuración esta abierta
--Para ello accede a la estrucutura interna de Ace-ConfigDialog que no esta documentada
--Esta libreria Ace lleva desde 2009 sin cambios por lo que no es probable que cambie.

  if ACD.OpenFrames["VoiceCoolDown"] ~= nil then 
    return true 
  else
    return false
  end
end;

function VoiceCoolDown:ConfigMonitorizedSpells()
--Esta función lo que hace es construir dinamicamente 
--las opciones de configuración de hechizos.
  
  local lHechizos
  
  for claseEnum, claseNombre in ipairs(CLASES_ENUM) do
    options.args.hechizos.args[claseNombre] = {
      name = L[claseNombre],
      type = "group",
      args={}
    }
    lHechizos = options.args.hechizos.args[claseNombre]
    for i, defecto in ipairs(HECHIZOS_PORDEFECTO) do 
      local clase = defecto[1]
      local spellid = defecto[2]
      local alliance = defecto[3]
      
      if clase == claseNombre then        
        lHechizos.args[tostring(spellid)] = {
          name = GetSpellInfo(spellid),
          type = "toggle",
          set = function(info, value) 
            if value then self:AddMonitorizedSpell(spellid)
            else self:DelMonitorizedSpell(spellid) end
          end,
          get = function()
            return self:IsMonitorizedSpell(spellid)
          end
        }
      end
    end
  end 
end
function VoiceCoolDown:EventFinReproduccionCD(token)
--Esta función se ejecuta cada vez que se termina una reproducción y lo que hace
--es indicar que ya termino la reproducción eliminando de hablando el token que se genero

  self:Print("Tokens eliminados")
  if self.Hablando[1] ~= token then 
    self:Print("Error") 
  end
  self:Print("1".." "..self.Hablando[1])
  table.remove(self.Hablando,1)
  self:Print("Tokens que quedan")
  for i,v in ipairs(self.Hablando) do
    self:Print(i.." "..v)
  end
end
function VoiceCoolDown:EventPlaySound(fichero)
--Reproduce el fichero de sonido que se envia por parametro
--teniendo en cuenta la configuración del usuario sobre el 
--canal maestro
  if self.db.global.Maestro then
    PlaySoundFile(self.db.global.RutaVoces..fichero..".mp3","Master")
  else
    PlaySoundFile(self.db.global.RutaVoces..fichero..".mp3")
  end
end
function VoiceCoolDown:PlaySoundFile(jugador, accion, hechizoID)
--Reproduce el fichero indicado de la ruta indicada pero tiene en cuenta
--si el usuario quiere que sea por el canal maestro ó no.  

--Cuando a wow le dices que reproduzca 3 ficheros de sonido lo que hace
--es que los supuerpone -> que tengo que usar temporizadores para que cada
--uno empieze despues del siguiente
  local idTimer  --Temporizador para empezar a reproducir 2º sonido de la frase
  local idTimer2 --Temporizador para reproducir 3er sonido de la frase
  local idTimer3 --Espera a que haya reproducido todo para permitir nuevas reproduciones
  
  local token = tostring(GetTime()) --Identificador de esta llamada a la función y por tanto de un reproducción de sonido de un CD en particular

  --if #self.Hablando > 2 then return end -- Si ya hay tres CD esperando a ser reproducidos no encola ninguno mas
  --Introduce en hablando un identificador único de la reproducción de este CD
  --uso como indentificador unico de est reproducción el tiempo trasncurrido desde que arranco el ordenador = GetTime()
  table.insert(self.Hablando,token)
  self:Print("Tokens en la lista")
  for i,v in ipairs(self.Hablando) do
    self:Print(i.." "..v)
  end
  --while self.Hablando[1] ~= token do
    --este bucle no hace nada, simplemente espera a que su token este el primero en la lista de reproducciones pendientes
  --end
  if jugador == nil then
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..accion..".mp3")
    end
    idTimer = self:ScheduleTimer("EventPlaySound", 0.45, hechizoID)
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 1.45, token)
  else
    if self.db.global.Maestro then
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3","Master")
    else
      PlaySoundFile(self.db.global.RutaVoces..jugador..".mp3")
    end
    idTimer = self:ScheduleTimer("EventPlaySound", 0.45, accion)
    idTimer2 = self:ScheduleTimer("EventPlaySound", 0.90, hechizoID)
    --Transcurrido este tiempo sabe que ya ha terminado esta reproducción por eso hay timer con un evento 
    --que borra el token de la lista que hay en reproducción. El tiempo es la suma de lo que tarda en decir
    --Jugador+Acción+Hehcizo = 0.45 +0.90 + 1 = 2.35
    idTimer3 = self:ScheduleTimer("EventFinReproduccionCD", 2.35, token)   end
end