local AddonName, VoiceCoolDown = ...
local oVoiceCoolDown = LibStub("AceAddon-3.0"):NewAddon(VoiceCoolDown, AddonName, "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("VoiceCoolDown") --Objeto para la gestión de la localización

local ACD = LibStub("AceConfigDialog-3.0")


local HECHIZOS_PORDEFECTO = {
	{"ANY",			59752,	nil},					-- Every Man for Himself
	{"ANY",			20594,	nil},					-- Stoneform: this is the spell in the spellbook
	--{"ANY",			65116,	nil},				-- Stoneform: this is the buff spell effect
	
	{"DRUID",		22812,	nil},					-- Barkskin
	{"DRUID",		22842,	nil},					-- Frenzied Regeneration
	{"DRUID",		29166,	nil},					-- Innervate
	{"DRUID",		20484,	nil},					-- Rebirth
	{"DRUID",		61336,	nil},					-- Survival Instincts
	{"DRUID",		740,	nil},					-- Tranquility
	{"DRUID",		33891,	nil},					-- Tree of Life
	{"DRUID",		5211,	nil},					-- Mighty Bash
	{"DRUID",		102351,	nil},					-- Cenarion Ward (Talent - 5.0)
	{"DRUID",		102342,	nil},					-- Ironbark (5.0)
	{"DRUID",		124974,	nil},					-- Nature's Vigil
	
	{"HUNTER",		34477,	nil},					-- Misdirection
	
	{"MAGE",		45438,	nil},					-- Ice Block
	{"MAGE",		31687,	nil},					-- Summon Water Elemental
	{"MAGE",		80353,	nil},					-- Time Warp
	{"MAGE",		2139,	nil},					-- Counterspell
	
	{"MONK",		115176,	nil},					-- Zen Meditation
	{"MONK",		116849,	nil},					-- Life Cocoon
	{"MONK",		115310,	nil},					-- Revival
	                                                   
	{"PALADIN",		31850,	nil},					-- Ardent Defender
	{"PALADIN",		31821,	nil},					-- Devotion Aura
	{"PALADIN",		498,	nil},					-- Divine Protection
	{"PALADIN",		642,	nil},					-- Divine Shield
	{"PALADIN",		1044,	nil},					-- Hand of Freedom
	{"PALADIN",		1022,	nil},					-- Hand of Protection
	{"PALADIN",		6940,	nil},					-- Hand of Sacrifice
	{"PALADIN",		1038,	nil},					-- Hand of Salvation
	{"PALADIN",		114039,	nil},					-- Hand of Purity
	{"PALADIN",		633,	nil},					-- Lay on Hands
	{"PALADIN",		20066,	nil},					-- Repentance
	{"PALADIN",		86659,	nil},					-- Guardian of Ancient Kings
	{"PALADIN",		96231,	nil},					-- Rebuke
	{"PALADIN",		853,	nil},					-- Hammer of Justice
	{"PALADIN",		105593,	nil},					-- Fist of Justice (5.0.4)
	                                                   
	{"PRIEST",		64843,	nil},					-- Divine Hymn
	{"PRIEST",		47788,	nil},					-- Guardian Spirit
	{"PRIEST",		64901,	nil},					-- Hymn of Hope
	{"PRIEST",		33206,	nil},					-- Pain Suppression
	{"PRIEST",		109964,	nil},					-- Spirit Shell (added in 5.0.4)
	{"PRIEST",		73325,	nil},					-- Leap of Faith
	{"PRIEST",		62618,	nil},					-- Power Word:Barrier
	{"PRIEST",		15286,	nil},					-- Vampiric Embrace
	{"PRIEST",		108968,	nil},					-- Void Shift
	{"PRIEST",		108920,	nil},					-- Void Tendrils (5.0.4)
	{"PRIEST",		113277,	nil},					-- Tranquility: Symbiosis (5.0.4)
	                                                   
	{"ROGUE",		2094,	nil},					-- Blind
	{"ROGUE",		31224,	nil},					-- Cloak of Shadows
	{"ROGUE",		57934,	nil},					-- Tricks of the Trade
	{"ROGUE",		1766,	nil},					-- Kick
	{"ROGUE",		114018,	nil},					-- Shroud of Concealment
	{"ROGUE",		76577,	nil},					-- Smoke Bomb
	                                                   
	{"SHAMAN",		2825,	"Horde"},				-- Bloodlust
	{"SHAMAN",		32182,	"Alliance"},			-- Heroism
	{"SHAMAN",		20608,	nil},					-- Reincarnation
	{"SHAMAN",		16190,	nil},					-- Mana Tide Totem
	{"SHAMAN",		98008,	nil},					-- Spirit Link Totem
	{"SHAMAN",		57994,	nil},					-- Wind Shear
	{"SHAMAN",		108280,	nil},					-- Healing Tide Totem
	{"SHAMAN",		5394,	nil},					-- Healing Stream Totem
	{"SHAMAN",		108281,	nil},					-- Ancestral Guidance
	                                                   
	{"WARLOCK",		698,	nil},					-- Ritual of Summoning
	{"WARLOCK",		29893,	nil},					-- Ritual of Souls
	{"WARLOCK",		20707,	nil},					-- Soulstone Resurrection
	                                                   
	{"WARRIOR",		871,	nil},					-- Shield Wall
	{"WARRIOR",		64382,	nil},					-- Shattering Throw
	{"WARRIOR",		12975,	nil},					-- Last Stand
	{"WARRIOR",		97462,	nil},					-- Rallying Cry
	{"WARRIOR",		6552,	nil},					-- Pummel
	{"WARRIOR",		102060,	nil},					-- Disrupting Shout
	{"WARRIOR",		114028,	nil},					-- Mass Spell Reflection
	{"WARRIOR",		114207, nil},					-- Skull Banner
	{"WARRIOR",		114203, nil},					-- Demoralizing Banner
	                                                   
	{"DEATHKNIGHT",	49576,	nil},					-- Death Grip
	{"DEATHKNIGHT",	48792,	nil},					-- Icebound Fortitude
	{"DEATHKNIGHT",	48707,	nil},					-- Anti-Magic Shell
	{"DEATHKNIGHT",	61999,	nil},					-- Raise Ally
	{"DEATHKNIGHT",	42650,	nil},					-- Army of the Dead
	{"DEATHKNIGHT",	49222,	nil},					-- Bone Shield
	{"DEATHKNIGHT",	55233,	nil},					-- Vampiric Blood
	{"DEATHKNIGHT",	46584,	nil},					-- Raise Dead
	{"DEATHKNIGHT",	51052,	nil},					-- Anti-Magic Zone
	{"DEATHKNIGHT",	47528,	nil},					-- Mind Freeze			--new
	{"DEATHKNIGHT",	47476,	nil},					-- Strangulate			--new
	{"DEATHKNIGHT",	49028,	nil},					-- Dancing Rune Weapon
	{"DEATHKNIGHT",	49039,	nil},					-- Lichborne
	{"DEATHKNIGHT",	48743,	nil},					-- Death Pact
}

-- Estrutura de datos para AceDB, esta es la estrutura de datos que usa AceDB para guardar las savevariables
local defaults = {
  global = { 
    --Indica si el addon esta activo o no, activando o no la recepción del evento COMBAT_LOG_EVENT_UNFILTERED 
    Activo = true,
    Maestro = true, -- Usar canal Maestro o no?
    RutaVoces = "Interface\\AddOns\\VoiceCoolDown\\Voces\\"
  },
  profile = {
		minimap = {
			hide = false,
		},
    hechizosEnCD = {}, --Esta Variable almacena como indice el identificador del timer y el spellid que monitoriza
    hechizos = {774, 1126, 29166, 102280} -- Variable que contiene los idspell a monitorizar
	},
}

--Estructura del frame de configuracion, lo usa Ace3-Config y Ace3-ConfigDialog
local options = {
  type = "group",
  childGroups = "tab",
  args = {
    generales={
      name = L["C_N_GENERAL"],
      desc = L["C_D_GENERAL"],
      type = "group",
      args={
        activo = {
          name = L["C_N_ACTIVO"],
          desc = L["C_D_ACTIVO"],
          type = "toggle",
          disabled = function()
            --Si estamos en situación de proceso de datos no debo
            --poder activar ni desactivar el addon para evitar
            --que se quede en situaciones no contempladas
            return (oVoiceCoolDown.EnCombate or oVoiceCoolDown.EnModoPrueba) 
          end,
          set = function(info, value) 
            -- Registramos o Desregistramos los eventos para activar o desactivar el addon.
            -- Cuando estemos en combate o en modo prueba esta opcion no se puede modificar
            oVoiceCoolDown.db.global.Activo = value
            if oVoiceCoolDown.db.global.Activo then 
              self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            else
              self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
              self:UnregisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged")
              self:UnregisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat")
              self:UnregisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") 
            end
          end,
          get = function()
            return oVoiceCoolDown.db.global.Activo
          end
        },
        maestro = {
          name = L["C_N_MAESTRO"],
          desc = L["C_D_MAESTRO"],
          type = "toggle",
          set = function(info, value) 
            -- Utiliza el canal maestro o no para las voces
            oVoiceCoolDown.db.global.Maestro = value  
          end,
          get = function()
            return oVoiceCoolDown.db.global.Maestro
          end
        },
        modoprueba = {
          name = L["C_N_MODO_PRUEBA"],
          desc = L["C_D_MODO_PRUEBA"],
          type = "toggle",
          set = function(info, value) 
            oVoiceCoolDown.EnModoPrueba = value
            if oVoiceCoolDown.EnModoPrueba then 
              oVoiceCoolDown:Print(L["MODO_PRUEBA_ACTIVO"])
            else
              oVoiceCoolDown:Print(L["MODO_PRUEBA_DESACTIVADO"])
            end
          end,
          get = function()
            return oVoiceCoolDown.EnModoPrueba
          end
        },
      }
    },
    hechizos={
      name = L["C_N_HECHIZOS"],
      desc = L["C_D_HECHIZOS"],
      type = "group",
      args={

        druida={
          name = L["DR"],
          type = "group",
          args={
            -- more options go here
          }
        }, -- Fin de clase
      
        caballero={
          name = L["DK"],
          type = "group",
          args={
            -- more options go here
          }
        }, -- Fin de clase
      
        chaman={
          name = L["CH"],
          type = "group",
          args={
            -- more options go here
          }
        }, -- Fin de clase
      
        paladin={
          name = L["PA"],
          type = "group",
          args={
            -- more options go here
          }
        } -- Fin de clase      
      
        -- more options go here
      }
    },
    moreoptions2={
      name = "More Options bis",
      type = "group",
      args={
        -- more options go here
      }
    }
  }
}
--Variables que no es necesario guardar cada vez que conectas/desconectas SAVEDVARIABLES
VoiceCoolDown.HoraComienzoCombateActual = time() --Contiene la hora a la que comienza el combate actual
VoiceCoolDown.HoraFinCombateActual = time() --Contiene la hora a la que termina el combate actual
VoiceCoolDown.TiempoTotalCombateActual = time() -- Duración del combate actual
VoiceCoolDown.RLOrdenaWipe = 0 --Esta variable determina si el RL ha indicado Wipe, Cada vez que comienze un combate se establece a 0
VoiceCoolDown.EnCombate = false --Esta variable determina si estamos en combate o no
VoiceCoolDown.EnModoPrueba = false --Esta claro no? sino lo ves dedicate a otra cosa.... 
VoiceCoolDown.MinimapButton = nil --Contendra un objeto LDB que definira los parametro del boton del minimapa
VoiceCoolDown.MinimapButtonIcon = nil --Contendra el objeto que crea un boton del minimapa a partir del objeto LDB anterior
VoiceCoolDown.db = nil --Contiene el objeto que almacena los datos de configuración para savedvariables.


function VoiceCoolDown:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("VoiceCoolDownDB", defaults) --Recupera datos guardados de la anterior sesión
  
  self:ConfigHechizos() --Esta linea debe de ir antes que la siguiente ya que carga adecuadamente el parametro "options"
  LibStub("AceConfig-3.0"):RegisterOptionsTable("VoiceCoolDown", options, "cvdconfig")
  LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VoiceCoolDown")
  --LibStub("AceConfigDialog-3.0"):SetDefaultSize("VoiceCoolDown",400,200)
  self:RegisterChatCommand("TBRWipe","RLWipe") --El RL mediante este comando indica que ha decidido wipe para el encuentro y se deja de tomar datos
  self:RegisterChatCommand("TBRShowIcon","ShowIcon") --Muestra u oculta el icono del minimapa.
  self:RegisterChatCommand("TBR",function() self:Print( L["addon_desc"])  end)
  self:CreateMinimapButton()
end

function VoiceCoolDown:OnEnable()
--Este evento se produce cuando el addon ya esta cargado
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","EventCombatLog")
  --self:RegisterEvent("ZONE_CHANGED_NEW_AREA","DetectInstanceChange") --Si cambia de instancia -> reset de la tabla almacenada?
  self:RegisterEvent("GROUP_ROSTER_UPDATE","PartyMembersChanged") --Si hay modificaciones en el grupo tengo que recalcular la estructura del grupo
  self:RegisterEvent("PLAYER_REGEN_DISABLED","EventStartCombat") --Este evento se produce cuando el jugador entra en combate
  self:RegisterEvent("PLAYER_REGEN_ENABLED","EventFinishCombat") --Este evento se produce cuando el jugador entra en combate
end

function VoiceCoolDown:EventoFinalTemporizador(currentIDspell)
  self:Print("5sg pasados")
  self:Print(currentIDspell)
  self:Print(self.db.global.Maestro)
  self:Print(self.db.global.RutaVoces)
  if self.db.global.Maestro then
    PlaySoundFile(self.db.global.RutaVoces.."aesoon"..".mp3","Master")
  else
    PlaySoundFile(self.db.global.RutaVoces.."aesoon"..".mp3")
  end
end
function VoiceCoolDown:EventCombatLog(event, ...)
--Esta función se activa cuando se dispara un evento de COMBAT_LOG_EVENT_UNFILTERED

  local timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, srcFlags2, destGUID, destName, destFlags, destFlags2, spellID, spellName = select(1, ...)
  local idTimer
  
  if not self:QProcessEventCombat() then return end
    
  if eventType == "SPELL_CAST_SUCCESS" and spellID == 102280 then
    idTimer = self:ScheduleTimer("EventoFinalTemporizador", 10, spellID)
    --hechizosEnCD[tostring(idTimer)] = spellID
      
  end
  if self:QIsInGroup(destName) or self:QIsInGroup(sourceName) or  (self.EnModoPrueba and ((destGUID == UnitGUID("player")) or (sourceGUID == UnitGUID("player")))) then --SI afecta a alguien del grupo.......
    self:Print("|cffffff00-------------------")
    self:Print(ChatFrame1,spellName)
    self:Print(ChatFrame1,eventType)
    if self:QIsInSpellList(spellID) then --Si esta en la lista de hechizos a procesar
      self:Print(ChatFrame1,"Hechizo incluido")
    end
  end
end
function VoiceCoolDown:EventStartCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_ENABLED y se limita a llamar
--a la función StartCombat que es la que inicializa todo lo necesario cuando comienza
--un combate.

  self:StartCombat()
end
function VoiceCoolDown:EventFinishCombat()
--Esta funcion recoge el disparo del evento PLAYER_REGEN_DISABLED y se limita a llamar
--a la función FinishCombat que es la que calcula y procesa todo lo necesario cuando ha
--terminado un combate.

  self:FinishCombat()
end
function VoiceCoolDown:StartCombat()
--Esta función inicia las variables necesarias cuando comienza el combate, 
--es llamada en el programa cuando se detecta el inicio de un combate

  self.HoraComienzoCombateActual = time() --Establece la hora de comienzo del combate
  self.EnCombate = true --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  
end
function VoiceCoolDown:FinishCombat()
--Esta funcion determina establece las variables necesarias cuando termina un combate
--y realiza los calculos necesarios al finalizar un combate.

  self.EnCombate = false --La funcion que procesa los eventos de combate usa esta variable para recoger o no datos
  self.HoraFinCombateActual = time() --Establece la hora de fin del combate
  self.TiempoTotalCombateActual = self.HoraFinCombateActual-self.HoraComienzoCombateActual
  self:Print(date("Tiempo total de combate is %M:%S",self.TiempoTotalCombateActual))
end
function VoiceCoolDown:RLWipe()
  self.RLOrdenaWipe = 1 --Esta variable cesa en la recolección de datos
  self:Print( L["WIPE"])
end
function VoiceCoolDown:ShowIcon()
  self:Print( self.db.profile.minimap.hide)
  self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	if self.db.profile.minimap.hide then
		self.MinimapButtonIcon:Hide("VoiceCoolDown!")
	else
    self.MinimapButtonIcon:Show("VoiceCoolDown!")
	end
  self:Print( self.db.profile.minimap.hide)
end

function VoiceCoolDown:CheckForWipe()
--Determina si ha habido wipe
	local wipe = true
	local num = GetNumGroupMembers()
	for i = 1, num do
		local name = GetRaidRosterInfo(i)
		if name then
			if UnitAffectingCombat(name) ~= nil then
				wipe = false
			end
		end
	end
	return wipe
end


function VoiceCoolDown:PartyMembersChanged()
--Esta función se ejecuta solo si se dispara el evento de GROUP_ROSTER_UPDATE
end
function VoiceCoolDown:GetGroupTypeAndCount()
--Determina el tipo de grupo: Party ó Raid y el número de miembros

	local type = "none"
	local count = GetNumGroupMembers()
	if IsInRaid() then
		type = "raid"
	elseif IsInGroup() then
		type = "party"
	end
  return type, count
end
function VoiceCoolDown:CreateMinimapButton()
--Utiliza para ello las librerias LDB y LDBI, crea un objeto
--LDB y lo registra como un icno del minimapa a través
--de un objeto LDBI
	local LDB = LibStub("LibDataBroker-1.1", true)
	if not LDB then return end
	self.MinimapButton = LDB:NewDataObject("VoiceCoolDown!", {
		type = "launcher",
		text = "VoiceCoolDown!",
		icon = "Interface\\AddOns\\VoiceCoolDown\\Images\\TBRMinimapButton",
		OnClick = function(_, button)
      self:Print("|cffffff00----------------------------------")
      if button == "RightButton" then 
        if self:QVentanaConfiAbierta() then return end
        self.EnModoPrueba = not self.EnModoPrueba
        if self.EnModoPrueba then 
          self:Print(L["MODO_PRUEBA_ACTIVO"])
          self:Print(VoiceCoolDown.SPELL_MONITOR_SCHEMA.schema)
        else
          self:Print(L["MODO_PRUEBA_DESACTIVADO"])
        end
      elseif button == "LeftButton" then 
        if self:QVentanaConfiAbierta() then return end
        self:RLWipe()
      else
        if self:QVentanaConfiAbierta() then 
          ACD:Close("VoiceCoolDown")
        else
          self:ConfigHechizos()
          ACD:Open("VoiceCoolDown")
        end
      end
    end,
    OnTooltipShow = function(tt)
      tt:AddLine("VoiceCoolDown")
      tt:AddLine("|cffffff00" .. L["TOOLTIP_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP2_MINIMAP"])
      tt:AddLine("|cffffff00" .. L["TOOLTIP3_MINIMAP"])
    end,
	})
	self.MinimapButtonIcon = LibStub("LibDBIcon-1.0", true)
	if self.MinimapButtonIcon then self.MinimapButtonIcon:Register("VoiceCoolDown!", self.MinimapButton, self.db.profile.minimap) end
end
function VoiceCoolDown:QProcessEventCombat()
--Esta función determina si hay que guardar el evento de combate. Es llamada en EventCombatLog
--Si devuelve true -> Procesa el evento de combate en curso.

  return  (not(self.RLOrdenaWipe) or self.EnCombate or self.EnModoPrueba)
end
function VoiceCoolDown:QIsInSpellList(spellid)
--Comprueba que el hechizo que se ha pasado por argumento este en la lista de hechizos a procesar en el combat log
--Esta funcion se llama desde la funcion que responde a los eventos de combat log

  if #self.db.profile.hechizos <= 0 then return false end
  for i = 1, #self.db.profile.hechizos do
    --self:Print(defaults.profile.hechizos[i])
    if self.db.profile.hechizos[i] == spellid then return true end
  end
  --self:Print(spellid)
  return false
end
function VoiceCoolDown:QIsInGroup(username)
--Esta función determina si username esta en banda, si es así procesara los spell del combat log
  
  local tipo -- Tipo de grupo = "party" o "banda" 
  local numero -- Cantidad de miembros en el grupo

  if not self:QProcessEventCombat() then return nil end --Si no esta en modo procesamiento -> No hay que comprobar
  
  tipo, numero = self:GetGroupTypeAndCount()
  if numero > 0 then 
    for i = 1, numero do 
      if username == GetRaidRosterInfo(i) then return true end
    end
  end
  return  false
end

function VoiceCoolDown:QVentanaConfiAbierta()
--Es una función que determina si la ventana de configuración esta abierta
--Para ello accede a la estrucutura interna de Ace-ConfigDialog que no esta documentada
--Esta libreria Ace lleva desde 2009 sin cambios por lo que no es probable que cambie.

  if ACD.OpenFrames["VoiceCoolDown"] ~= nil then 
    return true 
  else
    return false
  end
end;

function VoiceCoolDown:ConfigHechizos()
--Esta función lo que hace es construir dinamicamente 
--las opciones de configuración de hechizos.
--
  
  local lHechizos = options.args.hechizos.args 
  
  self:Print("CONFIGURANDO")
  for i, defecto in ipairs(HECHIZOS_PORDEFECTO) do
		
    local class = defecto[1]
		local spellid = defecto[2]
		local alliance = defecto[3]
    
    self:Print(class.." "..spellid)
    options.args.hechizos.args[tostring(spellID)] = {
      name = GetSpellInfo(spellid),
      type = "group",
      args={
            -- more options go here
      }
    }        
  end 
end